/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the GroupMembershipInfo type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GroupMembershipInfo{}

// GroupMembershipInfo struct for GroupMembershipInfo
type GroupMembershipInfo struct {
	MemberGroup *GroupInfo     `json:"memberGroup,omitempty"`
	Comment     NullableString `json:"comment,omitempty"`
}

// NewGroupMembershipInfo instantiates a new GroupMembershipInfo object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGroupMembershipInfo() *GroupMembershipInfo {
	this := GroupMembershipInfo{}
	return &this
}

// NewGroupMembershipInfoWithDefaults instantiates a new GroupMembershipInfo object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGroupMembershipInfoWithDefaults() *GroupMembershipInfo {
	this := GroupMembershipInfo{}
	return &this
}

// GetMemberGroup returns the MemberGroup field value if set, zero value otherwise.
func (o *GroupMembershipInfo) GetMemberGroup() GroupInfo {
	if o == nil || IsNil(o.MemberGroup) {
		var ret GroupInfo
		return ret
	}
	return *o.MemberGroup
}

// GetMemberGroupOk returns a tuple with the MemberGroup field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMembershipInfo) GetMemberGroupOk() (*GroupInfo, bool) {
	if o == nil || IsNil(o.MemberGroup) {
		return nil, false
	}
	return o.MemberGroup, true
}

// HasMemberGroup returns a boolean if a field has been set.
func (o *GroupMembershipInfo) HasMemberGroup() bool {
	if o != nil && !IsNil(o.MemberGroup) {
		return true
	}

	return false
}

// SetMemberGroup gets a reference to the given GroupInfo and assigns it to the MemberGroup field.
func (o *GroupMembershipInfo) SetMemberGroup(v GroupInfo) {
	o.MemberGroup = &v
}

// GetComment returns the Comment field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupMembershipInfo) GetComment() string {
	if o == nil || IsNil(o.Comment.Get()) {
		var ret string
		return ret
	}
	return *o.Comment.Get()
}

// GetCommentOk returns a tuple with the Comment field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupMembershipInfo) GetCommentOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Comment.Get(), o.Comment.IsSet()
}

// HasComment returns a boolean if a field has been set.
func (o *GroupMembershipInfo) HasComment() bool {
	if o != nil && o.Comment.IsSet() {
		return true
	}

	return false
}

// SetComment gets a reference to the given NullableString and assigns it to the Comment field.
func (o *GroupMembershipInfo) SetComment(v string) {
	o.Comment.Set(&v)
}

// SetCommentNil sets the value for Comment to be an explicit nil
func (o *GroupMembershipInfo) SetCommentNil() {
	o.Comment.Set(nil)
}

// UnsetComment ensures that no value is present for Comment, not even an explicit nil
func (o *GroupMembershipInfo) UnsetComment() {
	o.Comment.Unset()
}

func (o GroupMembershipInfo) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GroupMembershipInfo) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.MemberGroup) {
		toSerialize["memberGroup"] = o.MemberGroup
	}
	if o.Comment.IsSet() {
		toSerialize["comment"] = o.Comment.Get()
	}
	return toSerialize, nil
}

type NullableGroupMembershipInfo struct {
	value *GroupMembershipInfo
	isSet bool
}

func (v NullableGroupMembershipInfo) Get() *GroupMembershipInfo {
	return v.value
}

func (v *NullableGroupMembershipInfo) Set(val *GroupMembershipInfo) {
	v.value = val
	v.isSet = true
}

func (v NullableGroupMembershipInfo) IsSet() bool {
	return v.isSet
}

func (v *NullableGroupMembershipInfo) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGroupMembershipInfo(val *GroupMembershipInfo) *NullableGroupMembershipInfo {
	return &NullableGroupMembershipInfo{value: val, isSet: true}
}

func (v NullableGroupMembershipInfo) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGroupMembershipInfo) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
